"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAuctionSize = exports.create = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const generated_1 = require("./generated");
const constants_1 = require("./constants");
const create = async (context, input) => {
    const capacity = 'capacity' in input.configuration ? input.configuration.capacity : 1;
    const space = (0, exports.getAuctionSize)(capacity);
    return (0, umi_1.transactionBuilder)()
        .add((0, mpl_toolbox_1.createAccount)(context, {
        newAccount: input.auction,
        lamports: await context.rpc.getRent(space),
        space,
        programId: context.programs.getPublicKey('mplGavel', 'GAVELh8FYyRL9wpuFcdxxgjJ295R8fv8C7bXnpQ38YRL'),
    }))
        .add((0, generated_1.initialize)(context, {
        ...input,
        auction: input.auction.publicKey,
    }));
};
exports.create = create;
const getAuctionSize = (capacity) => constants_1.HEADER_SPACE + capacity * constants_1.ENTRY_SPACE;
exports.getAuctionSize = getAuctionSize;
//# sourceMappingURL=create.js.map