"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAuctionGpaBuilder = exports.safeFetchAllAuction = exports.fetchAllAuction = exports.safeFetchAuction = exports.fetchAuction = exports.deserializeAuction = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const types_1 = require("../types");
function deserializeAuction(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, (0, hooked_1.getAuctionAccountDataSerializer)());
}
exports.deserializeAuction = deserializeAuction;
async function fetchAuction(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Auction');
    return deserializeAuction(maybeAccount);
}
exports.fetchAuction = fetchAuction;
async function safeFetchAuction(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeAuction(maybeAccount) : null;
}
exports.safeFetchAuction = safeFetchAuction;
async function fetchAllAuction(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Auction');
        return deserializeAuction(maybeAccount);
    });
}
exports.fetchAllAuction = fetchAllAuction;
async function safeFetchAllAuction(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeAuction(maybeAccount));
}
exports.safeFetchAllAuction = safeFetchAllAuction;
function getAuctionGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplGavel', 'GAVELh8FYyRL9wpuFcdxxgjJ295R8fv8C7bXnpQ38YRL');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getAccountKeySerializer)()],
        mode: [8, (0, types_1.getModeSerializer)()],
        modeData: [16, (0, serializers_1.bytes)({ size: 32 })],
        authority: [48, (0, serializers_1.publicKey)()],
        auctioneer: [80, (0, serializers_1.publicKey)()],
        treasury: [112, (0, serializers_1.publicKey)()],
        mint: [144, (0, serializers_1.publicKey)()],
        startDate: [176, (0, umi_1.mapDateTimeSerializer)((0, serializers_1.i64)())],
        endDate: [184, (0, umi_1.mapDateTimeSerializer)((0, serializers_1.i64)())],
        gracePeriod: [192, (0, serializers_1.i64)()],
        startValue: [200, (0, serializers_1.u64)()],
        minimumValue: [208, (0, serializers_1.u64)()],
        tick: [216, (0, types_1.getTickSerializer)()],
        tickValue: [224, (0, serializers_1.u64)()],
        lowest: [232, (0, types_1.getKeySerializer)()],
        totalBids: [248, (0, serializers_1.u64)()],
        allocator: [256, (0, types_1.getAllocatorSerializer)()],
        treeNodes: [280, (0, serializers_1.array)((0, types_1.getTreeNodeSerializer)(), { size: 'remainder' })],
    })
        .deserializeUsing((account) => deserializeAuction(account))
        .whereField('key', types_1.AccountKey.Auction);
}
exports.getAuctionGpaBuilder = getAuctionGpaBuilder;
//# sourceMappingURL=auction.js.map