"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchBidFromSeeds = exports.fetchBidFromSeeds = exports.findBidPda = exports.getBidGpaBuilder = exports.safeFetchAllBid = exports.fetchAllBid = exports.safeFetchBid = exports.fetchBid = exports.deserializeBid = exports.getBidAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getBidAccountDataSerializer() {
    return (0, serializers_1.struct)([
        ['key', (0, types_1.getAccountKeySerializer)()],
        ['bump', (0, serializers_1.u8)()],
        ['padding', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 7 })],
        ['auction', (0, serializers_1.publicKey)()],
        ['owner', (0, serializers_1.publicKey)()],
        ['sequence', (0, serializers_1.u64)()],
        ['value', (0, serializers_1.u64)()],
        ['timestamp', (0, serializers_1.i64)()],
        ['history', (0, serializers_1.array)((0, types_1.getEntrySerializer)(), { size: 'remainder' })],
    ], { description: 'BidAccountData' });
}
exports.getBidAccountDataSerializer = getBidAccountDataSerializer;
function deserializeBid(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getBidAccountDataSerializer());
}
exports.deserializeBid = deserializeBid;
async function fetchBid(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Bid');
    return deserializeBid(maybeAccount);
}
exports.fetchBid = fetchBid;
async function safeFetchBid(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeBid(maybeAccount) : null;
}
exports.safeFetchBid = safeFetchBid;
async function fetchAllBid(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Bid');
        return deserializeBid(maybeAccount);
    });
}
exports.fetchAllBid = fetchAllBid;
async function safeFetchAllBid(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeBid(maybeAccount));
}
exports.safeFetchAllBid = safeFetchAllBid;
function getBidGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplGavel', 'GAVELh8FYyRL9wpuFcdxxgjJ295R8fv8C7bXnpQ38YRL');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getAccountKeySerializer)()],
        bump: [8, (0, serializers_1.u8)()],
        padding: [9, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 7 })],
        auction: [16, (0, serializers_1.publicKey)()],
        owner: [48, (0, serializers_1.publicKey)()],
        sequence: [80, (0, serializers_1.u64)()],
        value: [88, (0, serializers_1.u64)()],
        timestamp: [96, (0, serializers_1.i64)()],
        history: [104, (0, serializers_1.array)((0, types_1.getEntrySerializer)(), { size: 'remainder' })],
    })
        .deserializeUsing((account) => deserializeBid(account));
}
exports.getBidGpaBuilder = getBidGpaBuilder;
function findBidPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplGavel', 'GAVELh8FYyRL9wpuFcdxxgjJ295R8fv8C7bXnpQ38YRL');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('bid'),
        (0, serializers_1.publicKey)().serialize(seeds.auction),
        (0, serializers_1.publicKey)().serialize(seeds.owner),
    ]);
}
exports.findBidPda = findBidPda;
async function fetchBidFromSeeds(context, seeds, options) {
    return fetchBid(context, findBidPda(context, seeds), options);
}
exports.fetchBidFromSeeds = fetchBidFromSeeds;
async function safeFetchBidFromSeeds(context, seeds, options) {
    return safeFetchBid(context, findBidPda(context, seeds), options);
}
exports.safeFetchBidFromSeeds = safeFetchBidFromSeeds;
//# sourceMappingURL=bid.js.map