"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.bid = exports.getBidInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
function getBidInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.u8)()],
        ['amount', (0, serializers_1.u64)()],
    ], { description: 'BidInstructionData' }), (value) => ({ ...value, discriminator: 0 }));
}
exports.getBidInstructionDataSerializer = getBidInstructionDataSerializer;
// Instruction.
function bid(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplGavel', 'GAVELh8FYyRL9wpuFcdxxgjJ295R8fv8C7bXnpQ38YRL');
    // Accounts.
    const resolvedAccounts = {
        auction: { index: 0, isWritable: true, value: input.auction ?? null },
        bid: { index: 1, isWritable: true, value: input.bid ?? null },
        owner: { index: 2, isWritable: false, value: input.owner ?? null },
        payer: { index: 3, isWritable: true, value: input.payer ?? null },
        systemProgram: {
            index: 4,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
        auctioneer: {
            index: 5,
            isWritable: false,
            value: input.auctioneer ?? null,
        },
        splTokenProgram: {
            index: 6,
            isWritable: false,
            value: input.splTokenProgram ?? null,
        },
        splAtaProgram: {
            index: 7,
            isWritable: false,
            value: input.splAtaProgram ?? null,
        },
        ownerToken: { index: 8, isWritable: true, value: input.ownerToken ?? null },
        bidToken: { index: 9, isWritable: true, value: input.bidToken ?? null },
        mint: { index: 10, isWritable: false, value: input.mint ?? null },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.bid.value) {
        resolvedAccounts.bid.value = (0, accounts_1.findBidPda)(context, {
            auction: (0, shared_1.expectPublicKey)(resolvedAccounts.auction.value),
            owner: (0, shared_1.expectPublicKey)(resolvedAccounts.owner.value),
        });
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.systemProgram.value) {
        resolvedAccounts.systemProgram.value = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
        resolvedAccounts.systemProgram.isWritable = false;
    }
    if (!resolvedAccounts.splTokenProgram.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.splTokenProgram.value = context.programs.getPublicKey('splTokenProgram', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
            resolvedAccounts.splTokenProgram.isWritable = false;
        }
    }
    if (!resolvedAccounts.splAtaProgram.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.splAtaProgram.value = context.programs.getPublicKey('splAtaProgram', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL');
            resolvedAccounts.splAtaProgram.isWritable = false;
        }
    }
    if (!resolvedAccounts.ownerToken.value) {
        resolvedAccounts.ownerToken = {
            ...resolvedAccounts.ownerToken,
            ...(0, hooked_1.resolveOwnerTokenWhenMint)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    if (!resolvedAccounts.bidToken.value) {
        resolvedAccounts.bidToken = {
            ...resolvedAccounts.bidToken,
            ...(0, hooked_1.resolveBidTokenWhenMint)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getBidInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.bid = bid;
//# sourceMappingURL=bid.js.map