"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialize = exports.getInitializeInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getInitializeInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.u8)()],
        ['configuration', (0, types_1.getConfigurationSerializer)()],
    ], { description: 'InitializeInstructionData' }), (value) => ({ ...value, discriminator: 3 }));
}
exports.getInitializeInstructionDataSerializer = getInitializeInstructionDataSerializer;
// Instruction.
function initialize(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplGavel', 'GAVELh8FYyRL9wpuFcdxxgjJ295R8fv8C7bXnpQ38YRL');
    // Accounts.
    const resolvedAccounts = {
        auction: { index: 0, isWritable: true, value: input.auction ?? null },
        authority: { index: 1, isWritable: false, value: input.authority ?? null },
        treasury: { index: 2, isWritable: false, value: input.treasury ?? null },
        auctioneer: {
            index: 3,
            isWritable: false,
            value: input.auctioneer ?? null,
        },
        mint: { index: 4, isWritable: false, value: input.mint ?? null },
        treasuryToken: {
            index: 5,
            isWritable: true,
            value: input.treasuryToken ?? null,
        },
        splAtaProgram: {
            index: 6,
            isWritable: false,
            value: input.splAtaProgram ?? null,
        },
        payer: { index: 7, isWritable: true, value: input.payer ?? null },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.authority.value) {
        resolvedAccounts.authority.value = context.identity;
    }
    if (!resolvedAccounts.treasury.value) {
        resolvedAccounts.treasury.value = (0, shared_1.expectSome)(resolvedAccounts.authority.value);
    }
    if (!resolvedAccounts.treasuryToken.value) {
        resolvedAccounts.treasuryToken = {
            ...resolvedAccounts.treasuryToken,
            ...(0, hooked_1.resolveTreasuryTokenWhenMint)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    if (!resolvedAccounts.splAtaProgram.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.splAtaProgram.value = context.programs.getPublicKey('splAtaProgram', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL');
            resolvedAccounts.splAtaProgram.isWritable = false;
        }
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer = {
            ...resolvedAccounts.payer,
            ...(0, hooked_1.resolvePayerWhenMint)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getInitializeInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.initialize = initialize;
//# sourceMappingURL=initialize.js.map