"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.settle = exports.getSettleInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
function getSettleInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([['discriminator', (0, serializers_1.u8)()]], {
        description: 'SettleInstructionData',
    }), (value) => ({ ...value, discriminator: 4 }));
}
exports.getSettleInstructionDataSerializer = getSettleInstructionDataSerializer;
// Instruction.
function settle(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplGavel', 'GAVELh8FYyRL9wpuFcdxxgjJ295R8fv8C7bXnpQ38YRL');
    // Accounts.
    const resolvedAccounts = {
        auction: { index: 0, isWritable: true, value: input.auction ?? null },
        auctioneer: {
            index: 1,
            isWritable: false,
            value: input.auctioneer ?? null,
        },
        bid: { index: 2, isWritable: true, value: input.bid ?? null },
        owner: { index: 3, isWritable: true, value: input.owner ?? null },
        treasury: { index: 4, isWritable: true, value: input.treasury ?? null },
        mint: { index: 5, isWritable: false, value: input.mint ?? null },
        bidToken: { index: 6, isWritable: true, value: input.bidToken ?? null },
        ownerToken: { index: 7, isWritable: true, value: input.ownerToken ?? null },
        treasuryToken: {
            index: 8,
            isWritable: true,
            value: input.treasuryToken ?? null,
        },
        splTokenProgram: {
            index: 9,
            isWritable: false,
            value: input.splTokenProgram ?? null,
        },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.bid.value) {
        resolvedAccounts.bid.value = (0, accounts_1.findBidPda)(context, {
            auction: (0, shared_1.expectPublicKey)(resolvedAccounts.auction.value),
            owner: (0, shared_1.expectPublicKey)(resolvedAccounts.owner.value),
        });
    }
    if (!resolvedAccounts.bidToken.value) {
        resolvedAccounts.bidToken = {
            ...resolvedAccounts.bidToken,
            ...(0, hooked_1.resolveBidTokenWhenMint)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    if (!resolvedAccounts.ownerToken.value) {
        resolvedAccounts.ownerToken = {
            ...resolvedAccounts.ownerToken,
            ...(0, hooked_1.resolveOwnerTokenWhenMint)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    if (!resolvedAccounts.treasuryToken.value) {
        resolvedAccounts.treasuryToken = {
            ...resolvedAccounts.treasuryToken,
            ...(0, hooked_1.resolveTreasuryTokenWhenMint)(context, resolvedAccounts, resolvedArgs, programId, true),
        };
    }
    if (!resolvedAccounts.splTokenProgram.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.splTokenProgram.value = context.programs.getPublicKey('splTokenProgram', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
            resolvedAccounts.splTokenProgram.isWritable = false;
        }
    }
    if (!resolvedArgs.sequential) {
        resolvedArgs.sequential = false;
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getSettleInstructionDataSerializer().serialize({});
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.settle = settle;
//# sourceMappingURL=settle.js.map