import { DateTime } from '@metaplex-foundation/umi';
import { Serializer } from '@metaplex-foundation/umi/serializers';
import { Node } from '../flattenNodes';
import { Mode } from '../generated';
import { AuctionAccountData as BaseAuctionAccountData, AuctionAccountDataArgs as BaseAuctionAccountDataArgs } from '../generated/types/auctionAccountData';
export type DutlishModeData = {
    limitDate: DateTime;
    currentMode: Mode.English | Mode.Dutch;
};
export type AuctionAccountData = Omit<BaseAuctionAccountData, 'mode' | 'modeData'> & {
    nodes: Node[];
} & ({
    mode: Mode.UniformPrice;
} | {
    mode: Mode.English;
} | {
    mode: Mode.Dutch;
} | {
    mode: Mode.Dutlish;
    modeData: DutlishModeData;
});
export type AuctionAccountDataArgs = Omit<BaseAuctionAccountDataArgs, 'modeData'>;
export declare function getAuctionAccountDataSerializer(): Serializer<AuctionAccountDataArgs, AuctionAccountData>;
