"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAuctionAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const flattenNodes_1 = require("../flattenNodes");
const generated_1 = require("../generated");
const auctionAccountData_1 = require("../generated/types/auctionAccountData");
function getAuctionAccountDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, auctionAccountData_1.getAuctionAccountDataSerializer)(), (value) => ({
        ...value,
        modeData: new Uint8Array(32).fill(0),
    }), (value) => {
        const baseData = {
            ...value,
            nodes: (0, flattenNodes_1.flattenNodes)(value.allocator.root, value.treeNodes),
            modeData: undefined,
        };
        switch (value.mode) {
            case generated_1.Mode.Dutlish:
                return {
                    ...baseData,
                    mode: generated_1.Mode.Dutlish,
                    modeData: {
                        limitDate: (0, umi_1.mapDateTimeSerializer)((0, serializers_1.i64)()).deserialize(value.modeData)[0],
                        currentMode: (0, generated_1.getModeSerializer)().deserialize(value.modeData, 8)[0],
                    },
                };
            default:
                return { ...baseData, mode: value.mode };
        }
    });
}
exports.getAuctionAccountDataSerializer = getAuctionAccountDataSerializer;
//# sourceMappingURL=auctionAccountData.js.map