"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolvePayerWhenMint = exports.resolveTreasuryTokenWhenMint = exports.resolveBidTokenWhenMint = exports.resolveOwnerTokenWhenMint = void 0;
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const generated_1 = require("../generated");
const resolveOwnerTokenWhenMint = (context, accounts, _args, programId, isWritable) => {
    if (accounts.mint?.value) {
        return {
            value: (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
                owner: (0, generated_1.expectPublicKey)(accounts.owner?.value),
                mint: (0, generated_1.expectPublicKey)(accounts.mint.value),
            })[0],
            isWritable,
        };
    }
    return { value: programId, isWritable: false };
};
exports.resolveOwnerTokenWhenMint = resolveOwnerTokenWhenMint;
const resolveBidTokenWhenMint = (context, accounts, _args, programId, isWritable) => {
    if (accounts.mint?.value) {
        return {
            value: (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
                owner: (0, generated_1.expectPublicKey)(accounts.bid?.value),
                mint: (0, generated_1.expectPublicKey)(accounts.mint.value),
            })[0],
            isWritable,
        };
    }
    return { value: programId, isWritable: false };
};
exports.resolveBidTokenWhenMint = resolveBidTokenWhenMint;
const resolveTreasuryTokenWhenMint = (context, accounts, _args, programId, isWritable) => {
    if (accounts.mint?.value) {
        return {
            value: (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
                owner: (0, generated_1.expectPublicKey)(accounts.treasury?.value),
                mint: (0, generated_1.expectPublicKey)(accounts.mint.value),
            })[0],
            isWritable,
        };
    }
    return { value: programId, isWritable: false };
};
exports.resolveTreasuryTokenWhenMint = resolveTreasuryTokenWhenMint;
const resolvePayerWhenMint = (context, accounts, _args, programId, isWritable) => {
    if (accounts.mint?.value) {
        return {
            value: (0, generated_1.expectPublicKey)(accounts.payer?.value),
            isWritable,
        };
    }
    return { value: programId, isWritable: false };
};
exports.resolvePayerWhenMint = resolvePayerWhenMint;
//# sourceMappingURL=resolvers.js.map